function plot_compare_hist(expt)
% e.g. D5 or D5_K5

load(['toy_hist_samples_' expt]);

S = 1e5;

clf; hold all;
cc = -4:0.04:4;
h0 = bar_goop(exp(-0.5*(cc.^2))/sqrt(2*pi), cc);
h1 = histp_steps(pm_mh_samples(1:S, 1), cc);
h2 = histp_steps(pmc_mh_samples(1:floor(S/2), 1), cc);
xlim([-2.8 3.5]);
ylim([0 0.7]);

legh = legend([h0 h1 h2], {'Truth', 'PM', 'APM MI+MH'}, 'Location', 'NorthEast');
legend boxoff
pos = get(legh, 'Position');
pos(1) = pos(1) - 0.1;
pos(2) = pos(2) - 0.1;
set(legh, 'Position', pos);

figname = ['hist_toy_fair_' expt];
%set(gcf, 'PaperPosition', [1 1 2.5 3]*2.5);
%set(gcf, 'PaperPosition', [1 1 4.5 1.5]*3);
set(gcf, 'PaperPosition', [1 1 4.5 1.5]*2.6);
set(gca, 'OuterPosition', [0 0 1 1]);
%set(gca, 'Position', [0.2 0.2 0.5 0.5]);
print([figname, '.eps'], '-depsc');
system(['epstopdf ' figname, '.eps']);

