function plot_corr_compare(expt)

if nargin < 1
    error('Need expt, e.g. D5 or D5_K5');
end

load(['toy_expt_compare_' expt]);

more_file = sprintf('toy_expt_compare_more_%s.mat', expt);
if exist(more_file, 'file')
    % Error bands were a bit big (for K=1), so went and gathered more samples for standard PM method
    ws = load(sprintf('toy_expt_compare_more_%s', expt));
    acf_pm_mh = ws.acf_pm_mh;
    err_pm_mh = ws.err_pm_mh;
    scale_pm_mh = ws.scale_pm_mh;
end

figure(1);
clf; hold all;
h1 = plot_errorband(K*lags*scale_pm, acf_pm_mh, err_pm_mh);
h2 = plot_errorband(K*lags*scale_pmc_mh, acf_pmc_mh, err_pmc_mh);
h3 = plot_errorband(K*lags*scale_pmc_rslice, acf_pmc_rslice, err_pmc_rslice);
h4 = plot_errorband(K*lags*scale_pmc_eslice_mh, acf_pmc_eslice_mh, err_pmc_eslice_mh);
h5 = plot_errorband(K*lags*scale_pmc_eslice_rslice, acf_pmc_eslice_rslice, err_pmc_eslice_rslice);
plot([0 max_lag], [0 0], 'k--');
xlim([0 max_lag]);
ylim([-0.01 0.3]);
loc = 'NorthEast';
%loc = 'Best';
legend([h1 h2 h3 h4 h5], {'PM', 'APM MI+MH', 'APM MI+SS', 'APM SS+MH', 'APM SS+SS'}, 'Location', loc);
legend boxoff

figname = ['corr_toy_' expt];
%set(gcf, 'PaperPosition', [1 1 2.5 3]*2.5);
set(gcf, 'PaperPosition', [1 1 4.5 2.75]*3.5);
%set(gcf, 'PaperPosition', [1 1 4.5 2.75]*4.5); % Matlab 7.4
set(gca, 'OuterPosition', [0 0 1 1]);
set(gca, 'Position', [0.4 0.4 0.5 0.5]);
print([figname, '.eps'], '-depsc');
system(['epstopdf ' figname, '.eps']);

