function [xx, uu, Lfh] = pm_mh(log_fhat, xx, uu, type, widths, Lfh, varargin)

D = numel(xx);
x_prop = xx;

for dd = 1:D
    % Propose update for auxiliary variables
    if isequal(type, 'gaussian')
        u_prop = randn(size(uu));
    elseif isequal(type, 'uniform')
        u_prop = rand(size(uu));
    else
        error('Unknown type of uu');
    end
    x_prop(dd) = xx(dd) + widths(dd)*randn();
    
    Lfh_prop = log_fhat(x_prop, u_prop, varargin{:});
    if log(rand()) < (Lfh_prop - Lfh)
        % accept
        Lfh = Lfh_prop;
        uu = u_prop;
        xx(dd) = x_prop(dd);
    else
        x_prop(dd) = xx(dd);
    end
end

