function [xx, uu, Lfh, accept] = pm_mh_joint(log_fhat, xx, uu, type, widths, Lfh, varargin)

D = numel(xx);
x_prop = xx;

% Propose update for auxiliary variables
if isequal(type, 'gaussian')
    u_prop = randn(size(uu));
elseif isequal(type, 'uniform')
    u_prop = rand(size(uu));
else
    error('Unknown type of uu');
end

x_prop = xx + widths.*randn(size(xx));

Lfh_prop = log_fhat(x_prop, u_prop, varargin{:});
if log(rand()) < (Lfh_prop - Lfh)
    accept = 1;
    Lfh = Lfh_prop;
    uu = u_prop;
    xx = x_prop;
else
    accept = 0;
end

