function [xx, uu, Lfh] = pm_slice(log_fhat, xx, uu, type, widths, step_out, Lfh, varargin)

% Update auxiliary variables
log_udist = @(u) log_fhat(xx, u, varargin{:});
if isequal(type, 'gaussian')
    [uu, Lfh] = elliptical_slice(uu, randn(size(uu)), log_udist, Lfh);
elseif isequal(type, 'uniform')
    fixed_initial_brackets = [zeros(numel(uu), 1), ones(numel(uu), 1)];
    [uu, Lfh] = slice_sweep(log_udist, uu, fixed_initial_brackets, 0, Lfh);
else
    error('Unknown type of uu');
end

% Update target variables
log_xdist = @(x) log_fhat(x, uu, varargin{:});
[xx, Lfh] = slice_sweep(log_xdist, xx, widths, step_out, Lfh);

