function [xx, uu, Lfh] = pmc_eslice_mh_joint(log_fhat, xx, uu, width, Lfh, varargin)

% TODO CARE: assuming q(u) is Gaussian and not incorporated into log_fhat.

% Update auxiliary variables
log_udist = @(u) log_fhat(xx, u, varargin{:});
[uu, Lfh] = elliptical_slice(uu, randn(size(uu)), log_udist, Lfh);

% Update target variables
randn_ray = randn(size(xx));
direction = randn_ray / sqrt(randn_ray(:)'*randn_ray(:));
log_xdist = @(r) log_fhat(xx + r*direction, uu, varargin{:});
step_out = false;
[r, Lfh] = slice_sweep(log_xdist, 0, width, step_out, Lfh);
xx = xx + r*direction;

