global LOG_EFHAT_TOY_COUNTER;
global LOG_FHAT_TOY_COUNTER;

S = 1e5;

%D = 1;
D = 5;
%D = 50;
type = 'gaussian';
xx = randn(D, 1);
uu = randn(D, 1);
log_fhat = @toy_log_fhat;
Lfh = log_fhat(xx, uu);
widths = 2*ones(D, 1);

LOG_FHAT_TOY_COUNTER = 0;
mh_samples = zeros(S, D);
mh_cum_evals = zeros(S, 1);
fprintf('mh runs...\n');
for ss = 1:S
    if ~mod(ss, 1000)
        fprintf('Iteration %d / %d\r', ss, S);
    end
    [xx, uu, Lfh] = pm_mh_joint(log_fhat, xx, uu, type, widths, Lfh);
    mh_samples(ss, :) = xx(:)';
    mh_cum_evals(ss) = LOG_FHAT_TOY_COUNTER;
end
fprintf('\n');
mh_ess = effective_size_rcoda(mh_samples(:,1))
mh_ess_norm = mh_ess / mh_cum_evals(end)

% Slice both things:
type = 'gaussian';
xx = randn(D, 1);
uu = randn(D, 1);
log_efhat = @toy_log_efhat;
Lfh = log_efhat(xx, uu);
step_out = false;

LOG_EFHAT_TOY_COUNTER = 0;
slice_samples = zeros(S, D);
slice_cum_evals = zeros(S, 1);
fprintf('slice runs...\n');
for ss = 1:S
    if ~mod(ss, 1000)
        fprintf('Iteration %d / %d\r', ss, S);
    end
    [xx, uu, Lfh] = pm_eslice(log_efhat, xx, randn(size(xx)), uu, type, Lfh);
    slice_samples(ss, :) = xx(:)';
    slice_cum_evals(ss) = LOG_EFHAT_TOY_COUNTER;
end
fprintf('\n');
slice_ess = effective_size_rcoda(slice_samples(:,1))
slice_ess_norm = slice_ess / slice_cum_evals(end)

% And again with noisy slice:
type = 'bb_gaussian';
xx = randn(D, 1);
uu = randn(D, 1);
Lfh = log_efhat(xx, uu);
step_out = false;

LOG_EFHAT_TOY_COUNTER = 0;
b_slice_samples = zeros(S, D);
b_slice_cum_evals = zeros(S, 1);
fprintf('slice runs...\n');
for ss = 1:S
    if ~mod(ss, 1000)
        fprintf('Iteration %d / %d\r', ss, S);
    end
    [xx, uu, Lfh] = pm_eslice(log_efhat, xx, randn(size(xx)), uu, type, Lfh);
    b_slice_samples(ss, :) = xx(:)';
    b_slice_cum_evals(ss) = LOG_EFHAT_TOY_COUNTER;
end
fprintf('\n');
b_slice_ess = effective_size_rcoda(b_slice_samples(:,1))
b_slice_ess_norm = b_slice_ess / b_slice_cum_evals(end)

% And again noise-free slice but mh to update u:
type = 'clamp_gaussian';
xx = randn(D, 1);
uu = randn(D, 1);
Lfh = log_efhat(xx, uu);
step_out = false;

LOG_EFHAT_TOY_COUNTER = 0;
c_slice_samples = zeros(S, D);
c_slice_cum_evals = zeros(S, 1);
fprintf('slice runs...\n');
for ss = 1:S
    if ~mod(ss, 1000)
        fprintf('Iteration %d / %d\r', ss, S);
    end
    [xx, uu, Lfh] = pm_eslice(log_efhat, xx, randn(size(xx)), uu, type, Lfh);
    c_slice_samples(ss, :) = xx(:)';
    c_slice_cum_evals(ss) = LOG_EFHAT_TOY_COUNTER;
end
fprintf('\n');
c_slice_ess = effective_size_rcoda(c_slice_samples(:,1))
c_slice_ess_norm = c_slice_ess / c_slice_cum_evals(end)

save('toy_expt_joint');
