function toy_expt_steps_plot(expt)

if (nargin < 1) || isempty(expt)
    error('Provide experiment descriptor, e.g. pmc_D5');
end

name = sprintf('toy_expt_steps_%s', expt);
load(name);
fprintf('Based on run of length S=%d\n', S);

clf; hold on;
plot([step_sizes(1) step_sizes(end)], [0.234 0.234], '-', 'color', ones(1,3)*0.7);
% plot(step_sizes, ar_results, 'b');
% plot(step_sizes, ess_results*10, '--r');
[ax, p1, p2] = plotyy(step_sizes, ar_results, step_sizes, ess_results);
set(p2, 'LineStyle', '--');
set(p1, 'Color', 'b');
set(ax(1),'ycolor','b')
xlabel(ax(1),'step size')
ylabel(ax(1),'- accept rate')
ylabel(ax(2),'- - effective sample rate')

figname = name;

%set(gcf,'PaperUnits','centimeters')
%scale = 3;
%xSize = 4*scale; ySize = 3*scale;
%xLeft = (21-xSize)/2; yTop = (30-ySize)/2;
%set(gcf,'PaperPosition',[xLeft yTop xSize ySize])
%set(gcf,'Position',[300 600 xSize*50 ySize*50])
%xtick = get(gca, 'XTick');
%pp = get(gcf, 'PaperPosition');
set(gcf, 'PaperPosition', [1 1 2.5 3]*2.5);
set(ax(1), 'OuterPosition', [0 0 1 1]);
set(ax(2), 'OuterPosition', [0 0 1 1]);
set(ax(1), 'Position', [0.2 0.2 0.5 0.5]);
set(ax(2), 'Position', [0.2 0.2 0.5 0.5]);
%set(ax(2), 'OuterPosition', [0 0 1 1]);
%margin = get(ax(1),'TightInset') * [0;0;1;0] ;
%set(ax,'OuterPosition',[-margin 0 1+margin 1])
%set(ax, 'Position', [0.2 0.2 0.8 0.4])
%set(ax, 'Position', [0.2 0.2 0.8 0.4])
%set(ax,'OuterPosition',[0 0 1 1]);
%set(ax,'OuterPosition',[0 0 1 1]);
%set(gca, 'XTick', xtick);
print([figname, '.eps'], '-depsc');
system(['epstopdf ' figname, '.eps']);

