function Lfh = toy_log_efhat(xx, uu)

D = numel(xx);
K = numel(uu) / D; % Number of importance samples in estimator
assert(round(K) == K);

global LOG_EFHAT_TOY_COUNTER;
if isempty(LOG_EFHAT_TOY_COUNTER)
    LOG_EFHAT_TOY_COUNTER = K;
else
    LOG_EFHAT_TOY_COUNTER = LOG_EFHAT_TOY_COUNTER + K;
end

% Version assuming K=1
%Lfh = xx(:)'*uu(:) - xx(:)'*xx(:) + 0.5*xx(:)'*xx(:);
% or
%Lfh = xx(:)'*uu(:) - 0.5*xx(:)'*xx(:);

uu = reshape(uu, [D, K]);
Lfh = mean(xx(:)'*uu) - 0.5*xx(:)'*xx(:);
