function Lfh = toy_log_fhat(xx, uu)

D = numel(xx);
K = numel(uu) / D; % Number of importance samples in estimator
assert(round(K) == K);

global LOG_FHAT_TOY_COUNTER;
if isempty(LOG_FHAT_TOY_COUNTER)
    LOG_FHAT_TOY_COUNTER = K;
else
    LOG_FHAT_TOY_COUNTER = LOG_FHAT_TOY_COUNTER + K;
end

% Version assuming K=1
% Lfh = xx(:)'*uu(:) - xx(:)'*xx(:);

uu = reshape(uu, [D, K]);
Lfh = logsumexp(xx(:)'*uu) - xx(:)'*xx(:); % - log(K) ...
